require 'oj'
require 'nokogiri'

html = File.read('./api.html')
doc = Nokogiri::HTML(html)

tables = {}
headers = {}
res = {}
trRunCount = 0
tablesHeader = {}

doc.xpath('//table/tbody/tr').each do |row|
  pre = {}  
  tdNum = 1
  row.xpath('td').each do |cell|
    case cell.text
    when 'Field', 'Parameters'
      trRunCount = 1 if trRunCount > 1
      tablesHeader = {} if trRunCount > 1
    end
     
    if trRunCount == 1 
      tablesHeader[tdNum] = cell.text.strip.to_sym
    else
      case tablesHeader[tdNum]
      when :Type, :Field
        pre[tablesHeader[tdNum]] = cell.text.to_sym
      else
        pre[tablesHeader[tdNum]] = cell.text        
      end
    end
    
#     p "# trRunCount::#{trRunCount}, tdNum::#{tdNum}, tablesHeader::#{tablesHeader}, pre::#{pre}"    
    tdNum = tdNum + 1    
  end
  trRunCount += 1
#     p "#pre::#{pre}"    
  tables[row.line.to_i] = pre
end


doc.xpath('//h4').each do |row|
  headers[row.line] = row.text
end

headers.each do |row, content|
  i = 6
  while i < 12
    if tables.has_key?(row+i)
      res[content.to_sym] = tables[row+i]
      break
    else
      i = i+1
    end
  end
end

pp res
