########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module RedisPubSub
    class << self

      def subGetUnsub1(args)
        redisChannelPrefix = args[:x][:redis][:user_id]
        redisSubTimeout = 1
        
        subGetUnsub(args,redisChannelPrefix,redisSubTimeout)

      end
      
      def subGetUnsub2(args)
        redisChannelPrefix = args[:mmsg][:user_id]
        redisSubTimeout = 300
        
        subGetUnsub(args,redisChannelPrefix,redisSubTimeout)

      end    
        
      def subGetUnsub(args,redisChannelPrefix,redisSubTimeout)
        args[:x][:redis][:redisChannelpostfix].nil? ? args[:x][:redis][:redisChannelpostfix] = "" : true      
        redisChannel = "#{redisChannelPrefix}__#{args[:x][:redis][:subPostfix]}_#{args[:x][:redis][:redisChannelpostfix]}"      
        #redis ||=  Redis.new
        redis.subscribe_with_timeout(redisSubTimeout, redisChannel) do |on, subscriptions|    
          Dialog.logger.debug  "Subscribed to #{redisChannel} (#{subscriptions} subscriptions)"                  
          on.message do |channel, msg|
            Dialog.logger.debug "Redis READ from #{channel}, MSG: #{msg}"          
            args[:x][:redis][:answer] = Oj.load(msg) 
            redis.unsubscribe(redisChannel)
          end
        end
        rescue Redis::TimeoutError => @e
          true
      end    

    end    
  end
end
