########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Background
    class << self
    
      require 'active_support/time'
      require 'drb'            
      require_relative './../lib/require.rb'
      Dialog._require_min
      Dialog._require_background    
      Dir.glob(File.join("#{File.dirname(__FILE__)}/../lib/**", "*.rb")).each{|f| require f}
      
        Sidekiq.configure_server do |config|
          config.redis = { path: Dialog.config.db.redis_url, db: Dialog.config.db.redisDBBackground }
          config.average_scheduled_poll_interval = 5   ## DEV
        end

        Sidekiq.configure_client do |config|
          config.redis = { path: Dialog.config.db.redis_url, db: Dialog.config.db.redisDBBackground }
        end            
      
      ## DEV
      rs = Sidekiq::RetrySet.new
      rs.size
      rs.clear    
      ##
      
      Dir.glob(File.join("#{File.dirname(__FILE__)}/**", "*.rb")).each{|f| require f}
    
    end
  end
end
