########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Background
    class << self

      Sidekiq::Cron::Job.create(name: 'RedisDumper - every 1 min', cron: '*/1 * * * *', class: 'Dialog::Background::RedisDumper')
      pp Sidekiq::Cron::Job.all      
      
    end
    
    class RedisDumper
      include Sidekiq::Worker
      include Sidekiq::Status::Worker
      sidekiq_options queue: 'default'
      
      def perform
        puts Dialog::Statistics.redisDump2json
      end
      
    end
  
  end
end
