########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Canvas
    class << self
      
      def run(args)
        fqn = args[:mmsg][:fqn]
        args[:x][:fqn]="#{fqn[:c].capitalize}#{fqn[:o].capitalize}#{fqn[:f].capitalize}#{fqn[:g].capitalize}"
        Dialog.logger.debug("Try to run: Class: #{args[:x][:fqn]}\n")
        begin
          method = "get_#{Dialog.config.naming.app}#{args[:x][:fqn]}"
          Dialog::Generated.send(method.to_sym, args)
        rescue NoMethodError => @e
#           true
          Dialog.logger.error "Error in method run: #{@e.message}\n, #{@e.backtrace.join("\n\t")}" if @e    
        rescue => @e          
          raise
        end
      end       
      
    end
  end
end
#     
