########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module ElementSend
    class << self
      
      
      def kbForming(args, key)
        if args[:smsg].has_key?(key) 

          args[:smsg][:reply_markup][key] = args[:smsg][key]
          args[:smsg].delete(key)
        end
      end
    
      def send_DialogElementSendReply_keyboardStatic(args) 
        args[:smsg][:reply_markup] = {}
        kbForming(args, :one_time_keyboard)
        kbForming(args, :selective)
        kbForming(args, :resize_keyboard)
        args[:smsg][:reply_markup][:keyboard] = Dialog::ModSend.makeKeyboard(
          args, 
          :reply, 
          args[:x][:exec][:DialogElementSendReply_keyboardStatic][:DialogModElementReply_keyboardButton])
        send_DialogElementSendBot_messageSend(args)        
      end
                                                              
      def send_DialogModSendReply_keyboard(args)
          Telegram::Bot::Types::ForceReply.new(force_reply: true, selective: args[:x][:selective])
      end
                                                              
      def send_DialogModSendForce_reply(args)
        Telegram::Bot::Types::ReplyKeyboardRemove.new(remove_keyboard: true, selective:args[:x][:selective])
      end

      ###
      def send_DialogElementSendInline_keyboardStatic(args)     
        args[:smsg][:reply_markup] = { 
          inline_keyboard: Dialog::ModSend.makeKeyboard(
            args, 
            :inline, 
            args[:x][:exec][:DialogElementSendInline_keyboardStatic][:DialogModElementInline_keyboardButton])}
        send_DialogElementSendBot_messageSend(args)
      end
    
    end
  end
end
#     
