########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module ElementSend
    class << self

    
      def send_DialogElementSendRecognizeCode(args)
        name = "#{Dialog.config.path.dialogTmpfiles}/#{Dialog::Wrappers.downloadFile(args)}"
        attrs, stderr_str, status = Open3.capture3('/usr/bin/zbarimg', "-q", name)
        
        unless attrs == ""
          Dialog.logger.debug "#### muxFqn #{attrs}"
          response = attrs.split(':')
          codeType = response[0]
          response.shift
          text = answer_DialogModSendRecognizeCommonAction_success(codeType, response.join)
        else
          text = answer_DialogModSendRecognizeCommonAction_fail
        end
        args[:smsg][:text] = text
        args[:x][:dataRespRaw] = response  
        send_DialogElementSendBot_messageSend(args)                
      end  
      
        def answer_DialogModSendRecognizeCommonAction_success(codeType, response)
          <<-HEREDOC
  *Тип кода*: #{codeType} 
  *Содержание*: #{response}
          HEREDOC
        end    
        
        def answer_DialogModSendRecognizeCommonAction_fail
          <<-HEREDOC
  Изображение не содержит какой-либо код или сфотографировано не чётко.
          HEREDOC
        end           
          
    end
  end
end
#     
