########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Dialect
    class << self
    
      
      def repack_constructors_Element2ModSend(args, name, viewId)   
        args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:repack] ||= {}         
        repack_constructors_Element2ModSend_fFqn2tFqn(args, name, viewId, :fFqn2tFqn)
        repack_constructors_Element2ModSend_EInE_nores(args, name, viewId, :EInE_nores)      
      end

      
      def repack_constructors_Element2ModSend_fFqn2tFqn(args, name, viewId, repackName)  
        res = {} 
        args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:repack][repackName] ||= {}      
        args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:lookup].each do |tName, hash_tNameProp|
          hash_tNameProp.each do |fName, hash_fNameProp|
            res[hash_fNameProp[:fFqn].to_sym] ||= {}
            res[hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym] ||= {}
            res[hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym] = hash_fNameProp[:tProp] 
          end
        end  
        args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:repack][repackName] = res        
      end
      
      
      def repack_constructors_Element2ModSend_EInE_nores(args, name, viewId, repackName)  
        args[:dialect][:constructors][Dialog.config.naming.app.to_sym][:ElementsInElements][:lookup].each do |tName, hash_tNameProp|
          hash_tNameProp.each do |fName, hash_fNameProp|              
            
            args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:repack][:fFqn2tFqn][hash_fNameProp[:fFqn].to_sym].merge!(args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:repack][:fFqn2tFqn][hash_fNameProp[:tFqn].to_sym])
          end 
        end          
      end        
    
    end
  end
end
