########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Dialect
    class << self
    
      def repack_constructors_ElementsInElements(args, name, viewId)   
        args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:repack] = {}
        repack_constructors_ElementsInElements_fFqn(args, name, viewId, :fFqn)
      end

      def repack_constructors_ElementsInElements_fFqn(args, name, viewId, repackName)  
        res = {} 
        args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:repack][repackName] ||= {}      
        args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:lookup].each do |tName, hash_tNameProp|
          hash_tNameProp.each do |fName, hash_fNameProp|
            res[hash_fNameProp[:fFqn]] = hash_fNameProp
          end 
        end  
        args[:dialect][:constructors][Dialog.config.naming.app.to_sym][name][:repack][repackName] = res
      end
    
    end
  end
end
