########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Dialect
    class << self
    
    
      def repack_Expect2Events(args, name, viewId)    
        repack_Expect2Events_tEID_root(args, name, viewId, :tEID_root)      
      end
      
      
      def repack_Expect2Events_tEID_root(args, name, viewId, repackName)  
        res = {} 
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] ||= {}      
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:lookup].each do |tName, hash_tNameProp|
          hash_tNameProp.each do |fName, hash_fNameProp|
            res[hash_fNameProp[:tEID]] = {root: hash_fNameProp[:tFqn]}
          end 
        end  
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] = res
      end
        
    end
  end
end
