########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Dialect
    class << self

      def repack_Element2ModElements(args, name, viewId)   
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack] = {} 
        repack_Element2ModElements_fFqn(args, name, viewId, :fFqn)
        repack_Element2ModElements_atoms(args, name, viewId, :atoms)
        
      end

      def repack_Element2ModElements_fFqn(args, name, viewId, repackName)      
        res = {}
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] ||= {}                  
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:lookup].each do |tName, hash_tNameProp|
          hash_tNameProp.each do |fName, hash_fNameProp|         

  #           Dialog.logger.debug "### repack_Element2ModElements_fFqn - #{hash_fNameProp}"                      
            if args[:dialect][:constructors][Dialog.config.naming.app.to_sym][:DockedGroupings2AppFunctions][:repack][:tEID][hash_fNameProp[:fEID]]           
              res[hash_fNameProp[:fFqn].to_sym] ||= {}
              res[hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym] ||= {}
              res[hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym] = hash_fNameProp[:tProp]
              res[hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym] = hash_fNameProp[:tProp]              
            end        
          end 
        end    
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] = res            
      end     
      
        
      def repack_Element2ModElements_atoms(args, name, viewId, repackName)      
        if args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:AppEvent2Elements].is_a?(Hash)
          res = {atoms: {}, elements: {}}
          args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] ||= {}                  
          args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:lookup].each do |tName, hash_tNameProp|
            hash_tNameProp.each do |fName, hash_fNameProp|         

              if args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:AppEvent2Elements][:repack][:tOID].has_key?(hash_fNameProp[:fOID].to_sym)
  #               lookupDebug(name, hash_fNameProp)
                case hash_fNameProp[:tFqn] 
                when 'DialogModElementReply_keyboardButton', 'DialogModElementInline_keyboardButton', /DialogModElementInline_query_result*/
                  row = hash_fNameProp[:tProp][:pos].split(":")[0]
                  col = hash_fNameProp[:tProp][:pos].split(":")[1]
                  res[:keyboards] ||= {}
                  res[:keyboards][hash_fNameProp[:fOID]] ||= {}
                  res[:keyboards][hash_fNameProp[:fOID]][hash_fNameProp[:fFqn].to_sym] ||= {}                  
                  res[:keyboards][hash_fNameProp[:fOID]][hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym] ||= {}
                  res[:keyboards][hash_fNameProp[:fOID]][hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym][row] ||= {}
                  res[:keyboards][hash_fNameProp[:fOID]][hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym][row][col] = {:tName => hash_fNameProp[:tName], :tValue => hash_fNameProp[:tProp][:value]}
                  
                  if args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:ModElementsSpecs].is_a?(Hash)
                    if  args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:ModElementsSpecs][:repack][:tOID].has_key?(hash_fNameProp[:tOID].to_sym)
                      base = args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:ModElementsSpecs][:repack][:tOID][hash_fNameProp[:tOID].to_sym]
                      key = base[:fFqn].to_s.split /(?=[A-Z])/
                      res[:keyboards][hash_fNameProp[:fOID]][hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym][row][col][:spec] = {key: key.last.downcase, value: base[:fProp][:value]}
                    end
                  end
                  
                  
                when /^DialogElement/
#                   Dialog.logger.debug "### 2 #{hash_fNameProp[:tFqn]} - #{hash_fNameProp[:tOID]}"
                  res[:elements][hash_fNameProp[:fOID]] ||= {}
                  res[:elements][hash_fNameProp[:fOID]][hash_fNameProp[:tOID]] = hash_fNameProp[:tFqn]
                end
#                 Dialog.logger.debug "### 2 #{hash_fNameProp[:tFqn]} - #{res[:atoms][hash_fNameProp[:fOID]]}"  
                if res[:atoms][hash_fNameProp[:fOID]].is_a?(Hash)
                  res[:atoms][hash_fNameProp[:fOID]][hash_fNameProp[:tOID]][hash_fNameProp[:tFqn].to_sym][:tProp][row][col] = {tOID: hash_fNameProp[:tOID], tProp: hash_fNameProp[:tProp], modSend: modSend}   
                end
              end
            end 
          end    
          args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] = res   
        end
      end       
    

    end
  end
end
