########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Dialect
    class << self
    

      def repack_ElementChains(args, name, viewId)   
        repack_ElementChains_chain(args, name, viewId, :chain)            
      end

      
      def repack_ElementChains_chain(args, name, viewId, repackName)      
        step1Hash = {}
        step1Array = []
        step2Order = {}
        root = ""
        roots = []
        
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] ||= {}                  
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][:fOID].each do |fOID, hash_fOIDProp|
          step1Hash[fOID.to_sym] = hash_fOIDProp[:tOID].to_sym
          step1Array << fOID.to_sym unless step1Array.include?(fOID)
          step1Array << hash_fOIDProp[:tOID].to_sym unless step1Array.include?(hash_fOIDProp[:OID])        
          if args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:AppEvent2Elements][:repack][:tOID].has_key?(fOID.to_sym)
            roots << fOID
          end        
        end    
        
        
        roots.each do |root|
          baseRoot = root
          step2Order[root] ||= {}
          i=2
          cycle = 1
          step2Order[root][1] = root
          maxCycles = step1Array.count
          while cycle <= maxCycles 
            step1Hash.each do |fOID, tOID|
  #             Dialog.logger.debug "@@@1 i #{i}, step1Array.count #{step1Array.count}, if fOID #{fOID} ==  root #{root} => tOID #{tOID}"                          
              if fOID == root
                root = tOID.to_sym
                step2Order[baseRoot][i] = tOID
  #               Dialog.logger.debug "@@@2 i #{i}, step1Array.count #{step1Array.count}, fOID #{fOID}, tOID #{tOID}"              
                step1Array.delete(fOID) 
                step1Array.delete(tOID)     
                i = i +1
              end
              cycle += 1
            end    
          end
        end
        
        
        step3Final = {}
        step2Order.each do |root,v|
          step3Final[root] ||= {}
          step2Order[root].each do |step, fOID|
            step3Final[root][step] = {:oid => fOID.to_sym}        
            if args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:AppEvent2Elements][:repack][:tOID].has_key?(fOID)
              step3Final[root][step][:fqn] = args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:AppEvent2Elements][:repack][:tOID][fOID][:tFqn]
            else
              if args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:ElementChains][:repack][:fOID][fOID].is_a?(Hash)
                step3Final[root][step][:fqn] = args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:ElementChains][:repack][:fOID][fOID][:tFqn]
              else
                step3Final[root][step][:fqn] = args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][:ElementChains][:repack][:tOID][fOID][:tFqn]
              end
            end
#             Dialog.logger.debug "step #{step}, fqn #{step3Final[root][step]}"
          end
        end
#         Dialog.logger.debug "@@@ step3Final::#{step3Final}"

        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] = {:order => step3Final, :link => step1Hash}
      end        
    
    end  
  end
end
