########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog; module Naming; 
  module ChatContext
    def ChatContext.Private; 'private';  end  
    def ChatContext.Noman; 'noman';  end                
    def ChatContext.Botman; 'botman';  end          
    def ChatContext.Climan; 'climan';  end    
    def ChatContext.Fullman; 'fullman';  end          
  end
  
  module Class
      
    def Class.Event; 'event'; end
        module Event; module Order  
          
        def Order.Content; 'content';  end
        module Content; module Type      
          def Type.Original; 'original'; end    
          def Type.Edit; 'edit'; end    
          def Type.Reply; 'reply'; end    
          def Type.Forward; 'forward'; end   
        end; end;   
          
        module Content; module Family
          def Family.Media; 'media';  end
          module Media; module Genus
            def Genus.Photo; 'photo'; end
            def Genus.Document; 'document'; end            
            def Genus.Voice; 'voice'; end
            def Genus.Audio; 'audio'; end
            def Genus.Video; 'video'; end
            def Genus.Videonote; 'videonote'; end            
            def Genus.Sticker; 'sticker'; end
          end; end  
              
          def Family.Command; 'command';  end
          module Command; module Genus     
            def Genus.Telegram; 'telegram'; end          
            def Genus.Dialog; 'dialog'; end                      
          end; end   

          def Family.Simple; 'simple';  end  
          module Simple; module Genus     
            def Genus.Text; 'text'; end          
          end; end               
          def Family.Notext; 'notext';  end              
            
          def Family.Contact; 'contact';  end
          module Contact; module Genus     
            def Genus.Main; 'main'; end          
          end; end              
          def Family.Location; 'location';  end
          def Family.Invoice; 'invoice';  end                   
        end; end  
          
        def Order.Notify; 'notify';  end
        module Notify; module Family      
          def Family.ChatTitle; 'chattitle'; end
          def Family.Passport; 'passport'; end       
          module Passport; module Genus    
            def Genus.Personal_details; 'personal_details'; end
            def Genus.Passport; 'passport'; end
            def Genus.Driver_license; 'driver_license'; end
            def Genus.Identity_card; 'identity_card'; end
            def Genus.Internal_passport; 'internal_passport'; end
            def Genus.Address; 'address'; end
            def Genus.Utility_bill; 'utility_bill'; end
            def Genus.Bank_statement; 'bank_statement'; end
            def Genus.Rental_agreement; 'rental_agreement'; end
            def Genus.Passport_registration; 'passport_registration'; end
            def Genus.Temporary_registration; 'temporary_registration'; end
            def Genus.Phone_number; 'phone_number'; end
            def Genus.Email; 'email'; end            
          end; end                         
          def Family.ChatMember; 'chatmember'; end      
          module ChatMember; module Genus    
            def Genus.In_open; 'in_open'; end
            def Genus.In_link; 'in_link'; end                            
            def Genus.Invite; 'invite'; end
            def Genus.Leave; 'leave'; end                               
            def Genus.Ban; 'ban'; end                 
          end; end             
          def Family.ChatPhoto; 'chatphoto'; end        
          def Family.Create; 'create'; end        
          def Family.Migrate; 'migrate'; end                    
          def Family.Pinned; 'pinned'; end                    
          def Family.Login; 'login'; end                    
        end; end;
                
        def Order.Service; 'service';  end
        module Service; module Family      
          def Family.Inline; 'inline'; end   
          module Inline; module Genus
            def Genus.Query; 'query'; end
            def Genus.Cresult; 'cresult'; end              
#             def Genus.Answer; 'answer'; end
          end; end;            
          
          def Family.Callback; 'callback'; end
          module Callback; module Genus
            def Genus.Query; 'query'; end
          end; end;            
        end; end;
        
        def Order.Default; 'default';  end
        module Default; module Family      
          def Family.Default; 'default'; end   
          module Inline; module Genus
            def Default.Main; 'main'; end
          end; end;            
        end; end;              
        
        end; end;
    end
end; end;
            
#     module Message; module Family     
#       def Family.EditMessage; 'EditMessage';  end                   
#       def Family.Pin; 'Pin';  end
#       def Family.WebLogin; 'WebLogin';  end
#       def Family.GenusNone; 'GenusNone';  end                
#     end; end;
