########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Statistics
    class << self
    

      def general(args)
       
        msgLast  = {:key => 'msgLast', :value => args[:mmsg][:fqndata][:o][:msg][:date]}
        msgCount = {:key => 'msgCountOverall', :redisOp => 'inc'}
        
        ##UserOverall
        pushStatUserOverall(args, msgLast)
        pushStatUserOverall(args, msgCount)
        
        ##PerUser
        pushStatPerUser(args, msgLast)
        pushStatPerUser(args, msgCount)  

        ##PerChat
        pushStatPerChat(args, msgLast)
        pushStatPerChat(args, msgCount)      
        
        ##PerFQN
        pushStatFQNPerUser(args, msgLast)
        pushStatFQNPerUser(args, msgCount)          
       

      end         
      
    end
  end
end
