########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Storage
    module Redis
      class << self 

        def pushCachedPreprocChatContext(query, args)
          Dialog.clearApi(args)
          args[:smsg] = {chat_id: args[:mmsg][:fqndata][:o][:chat][:id]}
          args[:api][:op] = 'ChatAdministrators'
          a = Dialog::BotApi.apiActionGet(args)
          bman = 0;  cman = 0
          a['result'].each do |user|
            Dialog.logger.debug "userId #{user['user']['id']}, userStatus #{user['status']}; cliId #{args[:globals][:cliId]}, botId #{Dialog.config.naming.id}"
            cman = 1 if (user['user']['id'].to_i == args[:globals][:cliId]  and user['status'] == 'creator')
            bman = 1 if (user['user']['id'].to_i == Dialog.config.naming.id and user['status'] == 'administrator')
          end
          Dialog.logger.debug "Context args: @bman=#{bman} @cman=#{cman}"
          res = Dialog::Naming::ChatContext.Fullman if (bman == 1 and cman == 1)      
          res = Dialog::Naming::ChatContext.Botman if (bman == 1 and cman == 0)
          res = Dialog::Naming::ChatContext.Climan if (bman == 0 and cman == 1)
          res = Dialog::Naming::ChatContext.Noman if (bman == 0 and cman == 0)

          return res
        end
      
      end
    end 
  end
end
