########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Wrappers
    class << self
    
    def apiGetFilePath(file_id)
      c =  Dialog::BotApi.socks5_connection
      url="/bot#{Dialog.config.secure.token}/getFile?file_id=#{file_id}"      
      response = c.get url
      response_json = JSON.parse response.body
      file_path=response_json["result"]["file_path"]
      return file_path
    end
    
    
    def downloadFile(args)
      file = args[:mmsg][:fqndata][:f][:file]
      c = Dialog::BotApi.socks5_connection      
      url_file="/file/bot#{Dialog.config.secure.token}/#{file[:path]}"
      response = c.get url_file    
      file.has_key?(:name) ? name = file[:name] : name = file[:path].split('/')[1]
      File.open("#{Dialog.config.path.dialogTmpfiles}/#{name}", 'wb') { |fp| fp.write(response.body) }
      return name
    end
    
    
    end
  end
end 
