########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Triggers
    class << self    
   
      def erbGen(erbFile, dst, erb={})
        if not File.file?(dst)
          tmpl = ERB.new(File.read("#{Dialog.config.path.dialog_ruby}/exec/#{erbFile}")).result(binding)
          File.open(dst, 'w') do |f| f.write tmpl; end         
        end
      end
    
    
      def systemd(service, mode)
        Open3.popen3('/usr/bin/systemctl', '--user', 'daemon-reload')
        if mode == 'enstart'
          Open3.popen3('/usr/bin/systemctl', '--user', 'enable',  service)        
          Open3.popen3('/usr/bin/systemctl', '--user', 'restart', service)
        end
      end
    
      def trigger__run
        Dialog._run
      end
        
    end
  end
end
