########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Triggers
    class << self  
    
      def trigger_init
        require 'erb'      
        send("trigger_init_#{Dialog.config.run.mode.to_sym}", Dialog.config.run.mode)
        Dialog.logger.info "#{Dialog.config.run.mode} init finished successfully!"                          
      end
      
      def trigger_init_tdlib(mode)
        require 'tdlib-ruby'
        Dir.glob(File.join("#{Dialog.config.path.dialog_rubyLib}/tdlib/**", "*.rb")).each{|f| require f}         
        sess = Dialog::TDLib.tdlibInit
        Dialog::TDLib.tdlibAuth('user', sess)
      end
      
      def trigger_init_bot(mode)
        true
      end
      
      def trigger_init_bot_dev(mode)
        true
      end   
    
    end
  end
end
