########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module ElementData
    module SearchBaloo
      class << self
        
        def convert_Inline_query_resultArticle(args)     
          result = Array.new
          args[:x][:dataRespRaw].each do |ext, arrayName|  
            arrayName.each do |name|
              result << {id: rand(1 .. 90000), type: "article", title: "#{name}", input_message_content: {message_text: name}}
            end
          end
          args[:x][:dataResp] = result
          args[:x][:send][:results] = args[:x][:dataResp]    
        end
        
        
        def convert_Inline_query_resultDocument(args)     
          result = Array.new
          if args[:x][:dataRespRaw].has_key?(:pdf)
            args[:x][:dataRespRaw][:pdf].each do |name|  
                result << {id: rand(1 .. 90000), type: "document", title: "#{name}", mime_type: "application/pdf", document_url: "http://www.innosense.org/#{URI.escape(name)}"}
            end
          end
          args[:x][:dataResp] = result
          args[:x][:send][:results] = args[:x][:dataResp]    
        end    
        
      end
    end
  end
end
#     
