########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module ModSend
    class << self

    
      def makeKeyboard(args, mode, keyboardButtons)
        keyboard = Array.new
        keyboardButtons.each do |row, hash_col|      
#           Dialog.logger.debug "%%%%%%%% row - #{row},  hash_col - #{hash_col}"
          keyboard[row.to_i] ||= Array.new
          hash_col.sort.each do |col, prop|
            case mode
            when :reply
              keyboard[row.to_i] << {text: "#{prop[:tValue]}"}
            when :inline
              keyboard[row.to_i] << {text: "#{prop[:tValue]}", prop[:spec][:key] => "#{prop[:spec][:value]}"}
            end
          end
        end
        
        return keyboard.drop(1)            
      end     

    
    end
  end
end
#     
