########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module ModSend
    class << self
  
      def call_CompileElementFromAtoms(args, props, viewId)   
        args[:smsg] ||= {} 
                  
        if props.has_key?(:add) 
          fFqn = props[:fFqn].to_sym 
          tFqn = props[:tFqn].to_sym
          if args[:x][:exec].has_key?(fFqn)
            args[:x][:exec][fFqn][tFqn] = props[:tProp]
          end
          atomMux(args, props, viewId, fFqn, tFqn)        
        else
          fFqn = props[:tFqn].to_sym         
          args[:x][:exec][fFqn].each do |tFqn, prop|
#             Dialog.logger.debug "@@@@@@@@@@@@@ 1 - fFqn::#{fFqn}, tFqn::#{tFqn}, props::#{props}"            
          atomMux(args, props, viewId, fFqn, tFqn)  
          end
        end
      end

      
      def atomMux(args, props, viewId, fFqn, tFqn)  
        muxFqn = tFqn.to_s.split /(?=[A-Z])/
        if muxFqn[0] == 'Dialog'
          if muxFqn[1] == 'Mod' && muxFqn[2] == 'Send'
            Dialog.logger.debug "#### muxFqn #{muxFqn}"                  
            args[:x][:muxFqn] = {}
            args[:x][:muxFqn][3] = "#{muxFqn[0]}#{muxFqn[1]}#{muxFqn[2]}"
            args[:x][:muxFqn][4] = "#{muxFqn[0]}#{muxFqn[1]}#{muxFqn[2]}#{muxFqn[3]}"
            args[:x][:muxFqn][5] = "#{muxFqn[0]}#{muxFqn[1]}#{muxFqn[2]}#{muxFqn[3]}#{muxFqn[4]}"          
            args[:x][:muxFqn][:g] = muxFqn[4]
            run = "set_#{args[:x][:muxFqn][5]}"
            Dialog.logger.debug " @@@ pre-atomMux sender #{run}"                                               
            begin
              send(run.to_sym, args, fFqn, tFqn, props, viewId)                
            rescue NoMethodError => @e
              step = @e.message.split('`')[1].split('\'')[0].split /(?=[A-Z])/
              Dialog.logger.debug " @@@@@@@@@@@@@@@@@@@@ #{step.count} - #{@e.message}"                                               
              
              case step.count
              when 6 #runner
                begin          
                  Dialog.logger.debug " @@@ pre-atomMux sender #{step.count} - #{tFqn}"                       
                  send("set_#{tFqn}".to_sym, args, fFqn, tFqn, props, viewId)                  
                  Dialog.logger.debug " @@@ atomMux sender #{step.count} - #{tFqn}"     
                rescue NoMethodError
                  setterDefault(args, fFqn, tFqn, muxFqn[5].downcase, step.count)
                rescue => @e          
                  raise
                end                  
              when 7 #setter
                setterDefault(args, fFqn, tFqn, muxFqn[5].downcase, step.count)
              end
            rescue => @e          
              raise
            end
          end
        end
      end


      def setter(args, fFqn,  k, v)
        Dialog.logger.debug "## SET to FQN #{fFqn} :: K:#{k}, V:#{v}"
        case v
          when 'True', 'true'
            v = true
          when 'False', 'false'
            v = false
        end

        args[:smsg][k.to_sym] = v
      end
      
      def setterDefault(args, fFqn, tFqn, k, step)     
        Dialog.logger.debug " @@@ atomMux default pre-setter #{step} tFqn::#{tFqn} - #{k} :: #{args[:x][:exec][fFqn][tFqn]}"                                                                  
        setter(args, fFqn,  k, args[:x][:exec][fFqn][tFqn][:value])
        Dialog.logger.debug " @@@ atomMux default setter #{step} - #{k} :: #{args[:x][:exec][fFqn][tFqn][:value]}"                                                          
      end          
    
    end
  end
end
#     
