########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Dialect
    class << self
    
    
      def repack_Events2ModReceive(args, name, viewId)      
        repack_Events2ModReceive_fOID2tFqn(args, name, viewId, :fOID2tFqn)    
        repack_Events2ModReceive_fEID2tFqn(args, name, viewId, :fEID2tFqn)          
        repack_Events2ModReceive_tOID2fOID(args, name, viewId, :tOID2fOID)            
      end
      
      
      def repack_Events2ModReceive_fEID2tFqn(args, name, viewId, repackName)  
        res = {}
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] ||= {}            
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:lookup].each do |tName, hash_tNameProp|
          hash_tNameProp.each do |fName, hash_fNameProp|      
            res[hash_fNameProp[:fEID]] ||= {}
            res[hash_fNameProp[:fEID]][hash_fNameProp[:tFqn]] ||= {}
            res[hash_fNameProp[:fEID]][hash_fNameProp[:tFqn]][hash_fNameProp[:tProp][:scope]] ||= {}
            res[hash_fNameProp[:fEID]][hash_fNameProp[:tFqn]][hash_fNameProp[:tProp][:scope]][hash_fNameProp[:tOID]] = hash_fNameProp
          end 
        end     
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] = res      
      end    
      
      def repack_Events2ModReceive_fOID2tFqn(args, name, viewId, repackName)  
        res = {}
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] ||= {}            
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:lookup].each do |tName, hash_tNameProp|
          hash_tNameProp.each do |fName, hash_fNameProp|      
            res[hash_fNameProp[:fOID]] ||= {}
            res[hash_fNameProp[:fOID]][hash_fNameProp[:tFqn]] ||= {}
            res[hash_fNameProp[:fOID]][hash_fNameProp[:tFqn]][hash_fNameProp[:tProp][:scope]] ||= {}
            res[hash_fNameProp[:fOID]][hash_fNameProp[:tFqn]][hash_fNameProp[:tProp][:scope]][hash_fNameProp[:tOID]] = hash_fNameProp
          end 
        end     
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] = res      
      end

      
      def repack_Events2ModReceive_tOID2fOID(args, name, viewId, repackName) 
        res = {}      
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] ||= {}      
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][:fOID2tFqn].each do |fOID, hash_tFqn|
          hash_tFqn.each do |tFqn, hash_Scope|
            hash_Scope.each do |scope, hash_tOID|
              hash_tOID.each do |tOID, prop|
                  res[tOID] ||= {}
                  res[tOID][:fOID] = fOID
              end
            end
          end 
        end
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] = res
      end      
        
    end
  end
end
