########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Dialect
    class << self

      def repack_Element2ModSend(args, name, viewId)   
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack] = {} 
        repack_Element2ModSend_fFqn(args, name, viewId, :fFqn)
        repack_Element2ModSend_atoms(args, name, viewId, :atoms)
        
      end

      def repack_Element2ModSend_fFqn(args, name, viewId, repackName)      
        res = {}
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] ||= {}                  
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:lookup].each do |tName, hash_tNameProp|
          hash_tNameProp.each do |fName, hash_fNameProp|
  #           if args[:dialect][:constructors][Dialog.config.naming.app.to_sym][:DockedGroupings2AppFunctions][:repack][:tEID][hash_fNameProp[:fEID]]
  #             Dialog.logger.debug "### Element2ModSend_fFqn - #{hash_fNameProp[:fFqn]} - #{hash_fNameProp[:tFqn]} - #{hash_fNameProp[:tProp]}"          
              res[hash_fNameProp[:fFqn].to_sym] ||= {}
              res[hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym] ||= {}
              res[hash_fNameProp[:fFqn].to_sym][hash_fNameProp[:tFqn].to_sym] = hash_fNameProp[:tProp]
  #           end  
          end 
        end    
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] = res            
      end      

      
      def repack_Element2ModSend_atoms(args, name, viewId, repackName)      
        res = {atoms: {}}
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] ||= {}                  
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:lookup].each do |tName, hash_tNameProp|
          hash_tNameProp.each do |fName, hash_fNameProp|
            case hash_fNameProp[:tFqn] 
            when /DialogModSendInline_keyboardButton*/   
              next
            end
            res[:atoms][hash_fNameProp[:fOID]] ||= {}
            res[:atoms][hash_fNameProp[:fOID]][hash_fNameProp[:tOID]] ||= {}
            res[:atoms][hash_fNameProp[:fOID]][hash_fNameProp[:tOID]][hash_fNameProp[:tFqn].to_sym] = {:fFqn => hash_fNameProp[:fFqn],  :tProp => hash_fNameProp[:tProp]}
          end 
        end    
        args[:dialect][:perView][Dialog.config.naming.app.to_sym][viewId][name][:repack][repackName] = res            
      end        
      
  
    end
  end
end
