########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog  
  class << self
    
    def create
      Encoding.default_internal = Encoding::UTF_8
      Encoding.default_external = Encoding::UTF_8
      
      version = RUBY_VERSION.split('.').map { |x| x.to_i }
      if (version <=> [2, 4, 9]) >= 1
        require_relative './require.rb'
        _require_min
        Dialog::Triggers.send("trigger_#{Dialog.config.run.scope}".to_sym)
      else
        puts "Minimum required Ruby version - 2.5.0"
      end
    end
       
  end
end
    
