########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Metamess
    class << self

      def collect_EventContentCommand(args)
        metaStep(args, __method__.to_s)
        ### BODY
        commandType(args)      
        ### EOF BODY
        return final(args)
      end
      
      
    def commandType(args)
        case args[:mmsg][:fqndata][:o][:msg][:textStartWith]
        when /^_[а-яА-ЯёЁa-zA-Z0-9]..*.:.*[а-яА-ЯёЁa-zA-Z0-9]+$/
          delimiter = ":"
          args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Command::Genus.Dialog
        when /^_[а-яА-ЯёЁa-zA-Z0-9]*[^:]*\s*[а-яА-ЯёЁa-zA-Z0-9]+$/
          delimiter = "\s"
          args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Command::Genus.Dialog
        when /^\/[а-яА-ЯёЁa-zA-Z0-9]..*.:.*[а-яА-ЯёЁa-zA-Z0-9]+$/
          delimiter = ":"
          args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Command::Genus.Telegram
        when /^\/[а-яА-ЯёЁa-zA-Z0-9]*[^:]*\s*[а-яА-ЯёЁa-zA-Z0-9]+$/
          delimiter = "\s"   
          args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Command::Genus.Telegram
        else
          delimiter = false
        end
        Dialog.logger.debug("######  delimiter - #{delimiter} ")      
        
        if ! delimiter == false
          bot_fullcommand = args[:mmsg][:fqndata][:o][:msg][:textStartWith].split(delimiter)
          bot_command = bot_fullcommand[0].strip[1..-1].downcase
          
          if /.@.*/.match?(bot_command)
            if /.@#{args[:globals][:botUsername].downcase}.*/.match?(bot_command)
              bot_command = bot_command.split('@')[0]
            else
              Dialog.logger.error("######  COMMAND FOR OTHER BOT! ")
              raise
            end
          end
          
          if bot_fullcommand[1].nil?
            bot_subcommand = '_main' 
          else
            bot_fullcommand.shift
            bot_fullcommand.each do |v| 
              if /^#.*|^@.*/.match?(v)
                next
              else
                bot_subcommand = "#{bot_subcommand}_#{v.downcase}"
              end
            end
            bot_subcommand = '_main' if  bot_subcommand == ''          
          end
          
        else
          bot_command = args[:mmsg][:fqndata][:o][:msg][:textStartWith].strip[1..-1].downcase 
          bot_subcommand = '_main'
        end
        
        args[:mmsg][:fqndata][:f][:bot_command] = bot_command
        args[:mmsg][:fqndata][:f][:bot_subcommand] = bot_subcommand
      end        
      
      
      
      def collect_EventContentCommandDialog(args)
        metaStep(args, __method__.to_s)
        ### BODY
      
        ### EOF BODY
        return final(args)
      end    
      
      def collect_EventContentCommandTelegram(args)
        metaStep(args, __method__.to_s)
        ### BODY
      
        ### EOF BODY
        return final(args)
      end        
       
    end
  end
end
