########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Metamess
    class << self

      def collect_EventContentContact(args)
        metaStep(args, __method__.to_s)
        ### BODY
        args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Content::Family::Contact::Genus.Main
        
        ### EOF BODY
        return final(args)
      end
      
      def collect_EventContentContactMain(args)
        metaStep(args, __method__.to_s)
        ### BODY
        
        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:contact]'},                  
          :to           => {t1: '[:fqndata][:f][:contact]'},
          :fFields      => {v1: :phone_number, v2: :first_name, v3: :last_name, v4: :user_id},
        }) 
        
        ### EOF BODY
        return final(args)
      end    
       
    end
  end
end
