########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Metamess
    class << self
    
      def collect_EventNotifyChatmember(args)
        metaStep(args, __method__.to_s)
        ### BODY
        args[:rmsg][:new_chat_members].each do |member|
          args[:mmsg][:fqndata][:g] ||= {}
          if member[:id] == args[:rmsg][:from][:id] && member[:is_bot] == false
            if args[:rmsg][:chat][:username].nil?
              args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Notify::Family::ChatMember::Genus.In_link
            else
              args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Notify::Family::ChatMember::Genus.In_open            
            end
          else
            args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Notify::Family::ChatMember::Genus.Invite
          end

        end 
        
        unless args[:rmsg][:left_chat_member].nil?
          args[:mmsg][:fqndata][:g] = {}
          if args[:rmsg][:left_chat_member][:id] == args[:rmsg][:from][:id] && args[:rmsg][:left_chat_member][:is_bot] == false
            args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Notify::Family::ChatMember::Genus.Leave
          else            
            args[:mmsg][:fqnrun][:g] = Dialog::Naming::Class::Event::Order::Notify::Family::ChatMember::Genus.Ban
          end
        end        
        ### EOF BODY
        return final(args)
      end    
      
      def chatmemberCommon(args)      
        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:chat]'},               
          :to           => {t1: '[:fqndata][:o][:chat]'},
          :fFields      => {v1: :title},
          :fFieldsOpt   => {v1: :username},                                      
        }) 
      end
      
      def chatmemberInCommon(args)
        chatmemberCommon(args)   
        content_messageDefaults(args)      
        content_messageDefaultsGet(args)        
        content_userDefaults(args)      
        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:new_chat_members][0]'},                
          :to           => {t1: '[:fqndata][:g][:user]'},
          :fFields      => args[:x][:metamess][:userDefaults_fFields],
          :fFieldsOpt   => args[:x][:metamess][:userDefaults_fFieldsOpt],
        })        
      end
      
      
      def collect_EventNotifyChatmemberIn_link(args)
        metaStep(args, __method__.to_s)
        ### BODY
        chatmemberInCommon(args)        
        ### EOF BODY
        return final(args)
      end        
      
      def collect_EventNotifyChatmemberIn_open(args)
        metaStep(args, __method__.to_s)
        ### BODY
        chatmemberInCommon(args)
        ### EOF BODY
        return final(args)
      end   

      def collect_EventNotifyChatmemberInvite(args)
        metaStep(args, __method__.to_s)
        ### BODY
        chatmemberInCommon(args)
        ### EOF BODY
        return final(args)
      end        
      
      def chatmemberOutCommon(args)
        chatmemberCommon(args)   
        content_messageDefaults(args)      
        content_messageDefaultsGet(args)        
        content_userDefaults(args)      
        metamessGen(args,eval2mmsg = { 
          :from         => {f1: '[:left_chat_member]'},                
          :to           => {t1: '[:fqndata][:g][:user]'},
          :fFields      => args[:x][:metamess][:userDefaults_fFields],
          :fFieldsOpt   => args[:x][:metamess][:userDefaults_fFieldsOpt],
        })         
      end      
          
      
      def collect_EventNotifyChatmemberLeave(args)
        metaStep(args, __method__.to_s)
        ### BODY
        chatmemberOutCommon(args)
        ### EOF BODY
        return final(args)
      end   
      
      def collect_EventNotifyChatmemberBan(args)
        metaStep(args, __method__.to_s)
        ### BODY
        chatmemberOutCommon(args)
        ### EOF BODY
        return final(args)
      end       
            
    end
  end
end
