########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Statistics
    class << self
    
      def redisDump2json
      
        require 'redis/dump'
        require 'json'

        stat = {}
        redisDump = Redis::Dump.new 2, 'redis://localhost:4000'
        dump = redisDump.dump

        dump.each do |list|
          src = JSON.parse(list)
          preKey = src["key"].split(':')
          keyHead = preKey[0].to_sym
          stat[keyHead] ||= {}
          keySecond = preKey[1].to_sym
          stat[keyHead][keySecond] ||= {}
          
          preKey[2] ? keyType = preKey[2].to_sym : keyType = :main  
          stat[keyHead][keySecond][keyType] ||= {}
          
          src["value"].each do |data|
            stat[keyHead][keySecond][keyType][data[0][1..-1].to_sym] = data[1].to_i
          end
        end  


        json = JSON.generate(stat)
        return json
      end

    end
  end
end
