########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########

module Dialog
  module Storage
    module Redis
      class << self 


        def pushStat(query)
          Dialog.logger.debug "Redis pushToStat, typeKey::#{query[:typeKey]}, type::#{query[:type]}"        
          
          query.has_key?(:redisOp) ? op = query[:redisOp].to_sym : op = :write
          return redisDo({:type  => :stat, 
                          :op    => op, 
                          :data  => {hname: "#{query[:type]}:#{query[:typeKey]}", k: query[:key], v: query[:value]}, 
                          :query => query})
        end
        
      
      end
    end 
  end
end
