########    #######    ########    #######    ########    ########
##     / / / /    License    \ \ \ \ 
##    Copyleft culture, Copyright (C) is prohibited here
##    This work is licensed under a CC BY-SA 4.0
##    Creative Commons Attribution-ShareAlike 4.0 License
##    Refer to the http://creativecommons.org/licenses/by-sa/4.0/
########    #######    ########    #######    ########    ########
##    / / / /    Code Climate    \ \ \ \ 
##    Language = ruby
##    Indent = space;    2 chars;
########    #######    ########    #######    ########    ########
module Dialog
  module Lang
    class << self
    
      def initial
          I18n.load_path = Dir["#{Dialog.config.path.dialog_ruby}/lang/*.yml"]
          I18n.available_locales = [:en, :ru]
          I18n.default_locale = :ru    
          I18n.backend.load_translations
      end
    
    end
  end
end
